var _ = function() {
	var CanvasLib = new PlugIn.Library(new Version("1.0"));

	CanvasLib.getCanvasNames = function(){
		canvasNames = new Array()
		canvases.forEach(function(canvas){
			canvasNames.push(canvas.name)
		})
		return canvasNames
	}
	
	CanvasLib.removeAllCanvases = function(showAlert){
		if (canvases.length > 1){
			if (showAlert == true){
				var alert = new Alert("CONFIRMATION REQUIRED", "Are you sure you want to remove all but the first canvas?")
				alert.addOption("Cancel")
				alert.addOption("Remove")
				alert.show(function(result) {
					if (result == 0) {
						console.log("user cancelled")
					} else {
						for(var i = canvases.length; i--;) { 
							if(i != 0){canvases[i].remove()}
						}
					}
				})
			} else {
				for(var i = canvases.length; i--;) { 
					if(i != 0){canvases[i].remove()}
				}
			}
		}
	}
	
	CanvasLib.addCanvasForEveryMonth = function(showAlert){
		if(showAlert){
			var alert = new Alert("Confirmation Required", "Add a canvas for each month of the year?")
			alert.addOption("Continue")
			alert.addOption("Stop")
			alert.show(function(result){
				if (result == 1){
					throw new Error('script cancelled')
				} else {
					locale = "en-us"
					mths = new Array()
					for (i = 1; i < 12; i++) { 
						var date = new Date(i + "/1/2017"),
						month = date.toLocaleString(locale, { month: "long" })
						mths.push(month)
					}
					sze = document.windows[0].selection.canvas.size
					canvasNames = this.getCanvasNames()
					mths.forEach(function(mth){
						if(canvasNames.indexOf(mth) === -1){
							cnvs = addCanvas()
							cnvs.name = mth
							cnvs.size = sze
						}
					})
				}
			})
		} else {
			locale = "en-us"
			mths = new Array()
			for (i = 1; i < 12; i++) { 
				var date = new Date(i + "/1/2017"),
				month = date.toLocaleString(locale, { month: "long" })
				mths.push(month)
			}
			sze = document.windows[0].selection.canvas.size
			canvasNames = this.getCanvasNames()
			mths.forEach(function(mth){
				if(canvasNames.indexOf(mth) === -1){
					cnvs = addCanvas()
					cnvs.name = mth
					cnvs.size = sze
				}
			})
		}
	}
	
	CanvasLib.getNamedCanvas = function(canvasName){
		for(i = 0; i < canvases.length; i++){
			if (canvases[i].name.localeCompare(canvasName) == 0){
				return canvases[i]
			}
		}
		errorString = "There is no canvas named: " + canvasName
		// new Alert('ERROR', errorString).show(function(result){})
		throw new Error(errorString)
	}
	
	CanvasLib.newCanvasWithDimensions = function(cWpt, cHpt){
		cnvs = addCanvas()
		cnvs.size = new Size(cWpt, cHpt)
		return cnvs
	}
	
	CanvasLib.setDimensionsOfEveryCanvasTo = function(cWpt, cHpt){
		for(i = 0; i < canvases.length; i++){
			cnvs = canvases[i]
			cnvs.autosizesUp = cnvs.autosizesDown = cnvs.autosizesLeft = cnvs.autosizesRight = false
			cnvs.size = new Size(cWpt, cHpt)
		}
	}
	
	CanvasLib.setDimensionsOfCurrentCanvasTo = function(cWpt, cHpt){
		cnvs = document.windows[0].selection.canvas
		cnvs.autosizesUp = cnvs.autosizesDown = cnvs.autosizesLeft = cnvs.autosizesRight = false
		cnvs.size = new Size(cWpt, cHpt)
	}
	
	CanvasLib.setSizingModeOfCanvasToFixed = function(cnvs){
		cnvs.canvasSizingMode = CanvasSizingMode.Fixed
	}
	
	CanvasLib.setSizingModeOfCurrentCanvasToFixed = function(){
		cnvs = document.windows[0].selection.canvas
		cnvs.canvasSizingMode = CanvasSizingMode.Fixed
	}
	
	CanvasLib.getCurrentCanvas = function(){
		cnvs = document.windows[0].selection.canvas
		return cnvs
	}
	
	CanvasLib.moveCanvasToTop = function(cnvs){
		if (canvases.length > 1){
			if(cnvs.id != canvases[0].id){
				cnvs.orderBefore(canvases[0])
			}
		}	
	}
	
	CanvasLib.moveCanvasToBottom = function(cnvs){
		if (canvases.length > 1){
			if(cnvs.id != canvases[canvases.length-1].id){
				cnvs.orderAfter(canvases[canvases.length-1])
			}
		}
	}
	
	CanvasLib.deleteEveryCanvasExcept= function(cnvs){
		if (canvases.length > 1){
			if(cnvs.id != canvases[0].id){
				cnvs.orderBefore(canvases[0])
			}
			for(var i = canvases.length; i--;) { 
				if(i != 0){canvases[i].remove()}
			}
		}
	}
	
	CanvasLib.renameEveryCanvasToMatchOrder = function(){
		cvss = canvases.reverse()
		for(i = 0; i < cvss.length; i++){
			index = i + 1
			canvases[i].name = 'Canvas ' + index
		}
	}
	
	CanvasLib.setAutoSizingOfCurrentCanvas = function(trueFalse){
		cnvs = document.windows[0].selection.canvas
		cnvs.autosizesUp = cnvs.autosizesDown = cnvs.autosizesLeft = cnvs.autosizesRight = trueFalse
	}
	
	CanvasLib.setAutoSizingOfEveryCanvas = function(trueFalse){
		for(i = 0; i < canvases.length; i++){
			cnvs = canvases[i]
			cnvs.autosizesUp = cnvs.autosizesDown = cnvs.autosizesLeft = cnvs.autosizesRight = trueFalse
		}
	}
	
	CanvasLib.setSizeOfCurrentCanvasToMatchPageSize = function(){
		cnvs = document.windows[0].selection.canvas
		cnvs.autosizesUp = cnvs.autosizesDown = cnvs.autosizesLeft = cnvs.autosizesRight = false
		cnvs.size = new Size(cnvs.pageSize.width, cnvs.pageSize.height)
	}
	
	CanvasLib.setSizeOfEveryCanvasToMatchPageSize = function(){
		for(i = 0; i < canvases.length; i++){
			cnvs = canvases[i]
			cnvs.autosizesUp = cnvs.autosizesDown = cnvs.autosizesLeft = cnvs.autosizesRight = false
			cnvs.size = new Size(cnvs.pageSize.width, cnvs.pageSize.height)
		}
	}
	
	// returns a list of functions
	CanvasLib.handlers = function(){
		return "\n// CanvasLib ©2017 Nyhthawk Productions\n• getCanvasNames()\n• getNamedCanvas(canvasName)\n• addCanvasForEveryMonth()\n• removeAllCanvases(showAlertBoolean)\n• newCanvasWithDimensions(cWpt, cHpt)\n• setDimensionsOfEveryCanvasTo(cWpt, cHpt)\n• setDimensionsOfCurrentCanvasTo(cWpt, cHpt)\n• getCurrentCanvas()\n• moveCanvasToTop(cnvs)\n• moveCanvasToBottom(cnvs)\n• deleteEveryCanvasExcept(cnvs)\n• renameEveryCanvasToMatchOrder()\n• setAutoSizingOfCurrentCanvas(trueFalse)\n• setAutoSizingOfEveryCanvas(trueFalse)\n• setSizeOfCurrentCanvasToMatchPageSize()\n• setSizeOfEveryCanvasToMatchPageSize()"
	}
		
	// returns contents of matching strings file
	CanvasLib.documentation = function(){
		// look up the plugin
		var plugin = PlugIn.find("com.NyhthawkProductions.OmniGraffle")
		// get the url for the text file inside this plugin
		var url = plugin.resourceNamed("CanvasLib.strings")
		// read the file
		url.fetch(function (data){
			dataString = data.toString()
			console.log(dataString) // show in console
			return dataString
		})
	}
	
   return CanvasLib;
}();
_;