var _ = function(){
	var action = new PlugIn.Action(function(selection){
		var alert = new Alert("Canvas Setup", "Setup the current canvas to be a Title Center slide?")
		alert.addOption("Continue")
		alert.addOption("Cancel")
		alert.show(function(result){
			if (result == 0){
				var cnvs = document.windows[0].selection.canvas
				var cnvsSize = cnvs.size
				var cW = cnvsSize.width
				var cH = cnvsSize.height
				var vM = Math.round(cH/12)
				var hM = Math.round(cW/12)
				var boxOffset = Math.round(cH/32)
				var titleSize = Math.round(cW/14)
				var lineHeightPercentage = 1.25
				var titleBoxRect = new Rect(hM, cH/2 - (titleSize * lineHeightPercentage)/2, cW - hM*2, titleSize * lineHeightPercentage)
				var titleFontPSName = 'HelveticaNeue-Medium'
				// remove any existing title box
				titleBox = cnvs.graphicWithName('Slide Title')
				if (titleBox != null){
					titleBoxContent = titleBox.text
					titleBox.remove()
				} else {
					titleBoxContent = 'Slide Title'
				}
				// create a slide title box
				shape = cnvs.addShape('Rectangle',titleBoxRect)
				shape.name = 'Slide Title'
				shape.textHorizontalPadding = 0
				shape.textVerticalPadding = 0
				shape.text = titleBoxContent
				shape.fontName = titleFontPSName
				shape.autosizing = TextAutosizing.Overflow
				shape.textHorizontalAlignment = HorizontalTextAlignment.Center
				shape.textVerticalPlacement = VerticalTextPlacement.Middle
				shape.textSize = titleSize
				shape.fillColor = null
				shape.shadowColor = null
				shape.strokeColor = null
			} else {
				throw new Error('script cancelled')
			}
		})
	});

	// validation function
	action.validate = function(selection){
		return true
	};

	return action;
}();
_;